/*
 * $RCSfile$
 * $Date$
 * $Revision$
 * $Locker$
 * 
 * Description:
 *  Adds an ident string to the file that #includes it.  Would be nice if
 *   we could have it declare a macro to add the ident string, but it needs
 *   to give a preprocessor directive.  #define IS_IDENT_STRING to be the
 *   ident string (for the ISVS identification, should be "@(#) $Id$") before
 *   #including this header.  IS_IDENT_STRING will be #undefed after use.
 *
 * Implemented by:
 *  None.
 *
 * Author:
 *  francis, 28 Mar 1994
 *
 * Change Log:
 *  $Log$
 */
/* This file is the only one exempted from the requirement to have an
 * ident in every file--otherwise, we'd have far too many idents.
 */

/* This is also probably the only header that doesn't stop itself from
 * being #included twice, so that each header can get it.
 */
#include <ISident_time.h>

#ifdef IS_IDENT_STRING
#pragma ident IS_IDENT_STRING
#undef IS_IDENT_STRING
#endif
