#ifndef _DVE_AV_XT_H_
#define _DVE_AV_XT_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <dve/AVCtl/AVCtl.h>
#include <X11/Intrinsic.h>

/*
 * dveAVRegisterWithXt
 *   Registers the needed event processing with the Xt toolkit.
 *
 * Input : session : The session returned by dveAVOpenSession()
 *         context : The Xt application context
 * Output :
 * Return :
 * Notes :
 */
void dveAVRegisterWithXt(DveAVSession session, XtAppContext context);
  

/*
 * dveAVUnregisterWithXt
 *   Unregisters event processing with the Xt toolkit.
 * Input : session : The session returned by dveAVOpenSession()
 * Output :
 * Return :
 * Notes :
 */
void dveAVUnregisterWithXt(DveAVSession session);


#ifdef __cplusplus
}
#endif

#endif /* _DVE_AV_XT_H_ */
