#ifndef _DVE_AV__TRANSPORT_H_
#define _DVE_AV__TRANSPORT_H_

#ifdef __cplusplus
extern "C" {
#endif


#define DVE_AV_TRANSPORT_NAMELEN 255

typedef enum {
  dveAVInterfaceTypeNone=0,
  dveAVInterfaceTypeIP,
  dveAVInterfaceTypeATMPVC,
  dveAVInterfaceTypeATMSVC,
  dveAVInterfaceTypeH320      /* A H.320 call */
  } DveAVInterfaceType;

/* For H320, only dveAVTransportTypeUnicastUDP is supported */
typedef enum {
  dveAVTransportTypeInvalid=0,
  dveAVTransportTypeTCP,
  dveAVTransportTypeUnicastUDP,
  dveAVTransportTypeMulticastUDP
} DveAVTransportType;

typedef DveIPA DveAVNetworkAddressIP;

typedef struct {
  u_int32 vpi, vci;
} DveAVNetworkAddressATMPVC;

typedef struct {
  u_int32 dummy;
} DveAVNetworkAddressATMSVC;
  
typedef struct {
  char number[256];   /* Telephone number of H320 endpoint */
} DveAVNetworkAddressH320;

typedef struct {
  DveAVNetworkAddressIP address;
  u_int32 port;

} DveAVTransportArgIP;

typedef struct {
  DveAVNetworkAddressATMPVC address;
} DveAVTransportArgATMPVC;


typedef struct {
  DveAVNetworkAddressATMSVC address;
  u_int32 port;
} DveAVTransportArgATMSVC;

typedef struct {
  DveAVNetworkAddressH320 address;
  u_int32 kbpsMin, kbpsMax;     /* Bandwidth requirement */
} DveAVTransportArgH320;

typedef enum {
  dveAVTransportMaskInvalid=0,
  dveAVTransportMaskTCP = 1 << dveAVTransportTypeTCP,
  dveAVTransportMaskUnicastUDP = 1 << dveAVTransportTypeUnicastUDP,
  dveAVTransportMaskMulticastUDP = 1 << dveAVTransportTypeMulticastUDP
  } DveAVTransportMask;


/* The following defines how interfaces are reported by the transport domain */
typedef struct {
  DveAVNetworkAddressIP addr, broadcast;
  char hostName[DVE_AV_TRANSPORT_NAMELEN];
  char ifaceName[DVE_AV_TRANSPORT_NAMELEN];
} DveAVNetworkIfaceIP;

typedef struct {
  DveAVNetworkAddressATMPVC addr;
} DveAVNetworkIfaceATMPVC;

typedef struct {
  DveAVNetworkAddressATMSVC addr;
} DveAVNetworkIfaceATMSVC;

typedef struct {
  char name[32];     /* Telephone number */
} DveAVNetworkIfaceH320;

#ifdef __cplusplus
}
#endif

#endif /* _DVE_AV__TRANSPORT_H_ */
