/*
 * $RCSfile$
 * $Date$
 * $Revision$
 * $Locker$
 * 
 * Description:
 *  Declares the protocol between the conference engine & the calling
 *   engine.  This protocol is essentially just an encapsulation of the
 *   OpenDVE event & request protocols.
 *
 * Requires:
 *
 * Includes:
 *  <dve/events.h>
 *  <dve/requests.h>
 *
 * Implemented by:
 *  Something in the GBCS-specific conference engine.
 *  Something in the OpenDVE-specific calling engine.
 *
 * Classes:
 *
 * Types:
 *
 * Functions:
 *
 * Variables:
 *
 * Macros:
 *
 * Author:
 *  francis, 17 Mar 1995
 *
 * Known Bugs:
 *
 * Notes:
 *
 * Change Log:
 *  $Log$
 */
#ifndef _OPENDVE_CONFERENCE_ENGINE_TO_COMMWARE_ENGINE_PROTOCOL_H_
#define _OPENDVE_CONFERENCE_ENGINE_TO_COMMWARE_ENGINE_PROTOCOL_H_

#ifdef __cplusplus
extern "C" {
#endif

#define IS_IDENT_STRING "@(#) $Id$"
#include <ISident.h>

#include <dve/events.h>
#include <dve/requests.h>

enum {dveEngineToCWEngineProtocol=92,
	dveCWEnginePort=dveEngineToCWEngineProtocol,
	dveCWMgrPort=129
      };

typedef enum {
  dveEngineToCWEngineTagInvalid=0,
  /* Sent to calling engine */
  dveEngineToCWEngineTagRequest,

  /* Sent to conf engine */
  dveEngineToCWEngineTagEvent,
  dveEngineToCWEngineTagReportOpenDVEAddr,
  dveEngineToCWEngineTagReportSwitchAddr,
  dveEngineToCWEngineTagOpenConns,
  dveEngineToCWEngineTagCloseConns,

  /* Sent to calling engine--placed at end because it was added late */
  dveEngineToCWEngineReportMyAddr
} DveEngineToCWEngineTag;

typedef struct {
  DveRequest request;
} DveEngineToCWEngineMsgArgRequest;

typedef struct {
  DveIPAList addrs;
  u_int32 switchID;
} DveEngineToCWEngineMsgArgReportMyAddr;

typedef struct {
  DveEvent event;
} DveEngineToCWEngineMsgArgEvent;

typedef struct {
  DveUserHandle member;
  DveIPAList addrs; /* If addrs.numAddrs is 0, use the switch address */
  u_int32 switchID;
} DveEngineToCWEngineMsgArgReportOpenDVEAddr;

typedef struct {
  DveIPAList addrs;
  u_int32 switchID;
} DveEngineToCWEngineMsgArgReportSwitchAddr;

typedef union {
  DveEngineToCWEngineMsgArgRequest request;
  DveEngineToCWEngineMsgArgReportMyAddr reportMyAddr;

  DveEngineToCWEngineMsgArgEvent event;
  DveEngineToCWEngineMsgArgReportOpenDVEAddr reportOpenDVEAddr;
  DveEngineToCWEngineMsgArgReportSwitchAddr reportSwitchAddr;
} DveEngineToCWEngineMsgArg;

typedef struct {
  DveEngineToCWEngineMsgArg arg;
} DveEngineToCWEngineMsg;

#ifdef __cplusplus
}
#endif

#endif /*_OPENDVE_CONFERENCE_ENGINE_TO_COMMWARE_ENGINE_PROTOCOL_H_*/
