#ifndef _DVE_MULTIMEDIA_SHARED_MEM_H_
#define _DVE_MULTIMEDIA_SHARED_MEM_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <IStypes.h>

typedef struct _DveMmShm* DveMmShm;

DveMmShm dveMmShmCreate(u_int32 bufsize,
			u_int32 controlsize,
			int key);
DveMmShm dveMmShmCreateAnonymous(u_int32 bufsize,
				 u_int32 controlsize);
DveMmShm dveMmShmAttachByKey(u_int32 bufsize,
			     u_int32 controlsize,
			     int key);
DveMmShm dveMmShmAttachById(u_int32 bufsize,
			    u_int32 controlsize,
			    int id);
int dveMmShmGetKey(DveMmShm shm);
int dveMmShmGetId(DveMmShm shm);
void dveMmShmDetach(DveMmShm shm);
void dveMmShmDestroy(DveMmShm shm);

void* dveMmShmGetBuff(DveMmShm shm);
u_int32 dveMmShmGetBuffSize(DveMmShm shm);
void* dveMmShmGetControls(DveMmShm shm);

int dveMmShmWrite(DveMmShm shm,
		  const char* data,
		  int nbytes);
int dveMmShmPauseWriter(DveMmShm shm);
int dveMmShmResetWriter(DveMmShm shm);

/* Return values:
 *  >0: num bytes read
 *  -1: nothing to read
 *  -2: Fell too far behind; synched up now.
 *  -3: Got reset.
 *  -4: Paused
 *  -5: Unknown packet type; synched up now.
 *
 * Note that, as far as the caller is concerned, -1, -2, -3, and -5 are
 *  just "nothing to read".
 */
int dveMmShmRead(DveMmShm shm,
		 char* data,
		 int maxbytes);
int dveMmShmPeek(DveMmShm shm);

#ifdef __cplusplus
}
#endif

#endif /*_DVE_MULTIMEDIA_SHARED_MEM_H_*/
