/*
 * $RCSfile$
 * $Date$
 * $Revision$
 * $Locker$
 * 
 * Description:
 *  Defines the protocol used by plugins to make requests of the engine.
 *
 * Requires:
 *  <IStypes.h>
 *
 * Implemented by:
 *  dve.c
 *  pluginmgr.c
 *
 * Types:
 *  DveReqTag
 *  DveReqSetEventArg
 *  DveReqInitiateArg
 *  DveReqAddMemberArg
 *  DveReqSetDNDArg
 *  DveReqArg
 *  DveRequest
 *
 * Author:
 *  francis, ?? Feb 1994
 *
 * Change Log:
 *  $Log$
 */
#ifndef _DVE_REQUESTS_H_
#define _DVE_REQUESTS_H_

#ifdef __cplusplus
extern "C" {
#endif

#define IS_IDENT_STRING "@(#) $Id$"
#include <ISident.h>

typedef enum
{
  dveReqTagInvalid=0,
  dveReqTagSetEventMask,
  dveReqTagFirst=dveReqTagSetEventMask,
  dveReqTagInitiate,
  dveReqTagAddMember,
  dveReqTagLeaveConf,
  dveReqTagSetDND,
  dveReqTagInitiateNew,
  dveReqTagAddMemberNew,
  dveReqTagLast=dveReqTagAddMemberNew
} DveReqTag;

typedef struct {
  DveEventMask mask;
} DveReqSetEventArg;

typedef struct {
  char userName[DVE_MAXNAME+1];
  char hostName[DVE_MAXHOST+1];
  char align[2];
} DveReqInitiateOrAddMemberArg_Addr;

typedef struct {
  /* Following list excludes the initiator */
  int numMembers;
  DveReqInitiateOrAddMemberArg_Addr addresses[1];
} DveReqInitiateArg;

typedef struct {
  DveReqInitiateOrAddMemberArg_Addr address;
} DveReqAddMemberArg;

typedef struct {
  Bool16 DND;
} DveReqSetDNDArg;

typedef struct {
  char userName[DVE_MAXNAME];
  char hostName[DVE_MAXHOST];
  DveIPAList addrs;
} DveReqInitiateOrAddMemberNewArg_Addr;

typedef struct {
  /* Following list excludes the initiator */
  int numMembers;
  DveReqInitiateOrAddMemberNewArg_Addr addresses[1];
} DveReqInitiateNewArg;

typedef struct {
  DveReqInitiateOrAddMemberNewArg_Addr address;
} DveReqAddMemberNewArg;

typedef union {
  DveReqSetEventArg setEvent;
  DveReqInitiateArg initiate;
  DveReqAddMemberArg addMember;
  DveReqSetDNDArg setDND;
  DveReqInitiateNewArg initiateNew;
  DveReqAddMemberNewArg addMemberNew;
} DveReqArg;

typedef struct {
  u_int32 size;
  u_int32 reqID, evtID;
  DveReqTag tag;
  DveReqArg arg;
} DveRequest;

#ifdef __cplusplus
}
#endif

#endif /*_DVE_REQUESTS_H_*/
