#include "menu.h"

enum {True=1, False=0};

typedef enum {optionsMenu=0, inputMenu} MenuType;

typedef struct _menu *Menu;
typedef struct _menuItem MenuItem;
typedef void (*menuHandler) (DveAVSession session, char *s);  


struct _menuItem {
  char *message;
  void (*handler) (DveAVSession session, char *s);  

  int input;               /* Is input required? */
  Menu *subMenu;           /* 0 if no Sub-menu */
};

struct _menu {
  MenuType type;
  void (*initial) (DveAVSession);
  void (*final) (DveAVSession);
  MenuItem *items;
};


/* Main menu description  */
menuHandler startVideo, stopVideo;
MenuItem mainMenuItems[] = {
  {"Change Video Board", 0, False, changeVideoBoardMenu},
  {"Start Video", startVideo, False, 0},
  {"Stop Video", stopVideo, False, 0},
  {"Add sending Member", 0, False, addSendingMemberMenu},
  {"Remove sending Member", 0, False, removeSendingMemberMenu},
  {"Add receiving Member", 0, False, addReceivingMemberMenu},
  {"Remove receiving Member", 0, False, removeReceivingMemberMenu},
  {0, 0, 0, 0}
};

Menu mainMenu = {
  optionsMenu,
  0, 
  0,
  mainMenuItems
  };


