#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/MwmUtil.h>
#include <Xm/MenuShell.h>
 
#include <Xm/Scale.h>
#include <Xm/TextF.h>
#include <Xm/LabelG.h>
#include <Xm/Frame.h>
#include <Xm/CascadeB.h>
#include <Xm/ToggleB.h>
#include <Xm/Separator.h>
#include <Xm/SeparatoG.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <X11/Shell.h>
#include <Xm/Protocols.h>
#include <Xm/List.h>

/* 
 * OpenDVE related includes...
 */
#include <dve/dve.h>
#include <dve/dvePluginMgr.h>


typedef struct {
  char *label;
  WidgetClass *class;
  char mnemonic;
  char *accelerator;
  char *accelText;
  XtCallbackProc callback;
  XtPointer callbackData;
 
} MenuItem;

void ifaceRunAllCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceStopAllCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceShowAllCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceHideAllCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceExitCallback(Widget w, XtPointer cld, XtPointer cad);

 
static MenuItem fileMenuItems[] = {
  {"Run All Plugins", &xmPushButtonGadgetClass, 'R', 0, 0, 
     ifaceRunAllCallback, 0},
  {"Stop All Plugins", &xmPushButtonGadgetClass, 'S', 0, 0, 
     ifaceStopAllCallback, 0},
  {"", &xmSeparatorGadgetClass, 0, 0, 0, 0, 0},
  {"Show All Plugins", &xmPushButtonGadgetClass, 'w', 0, 0, 
     ifaceShowAllCallback, 0},
  {"Hide All Plugins", &xmPushButtonGadgetClass, 'H', 0, 0, 
     ifaceHideAllCallback, 0},
  {"", &xmSeparatorGadgetClass, 0, 0, 0, 0, 0},
  {"Exit", &xmPushButtonGadgetClass, 'E', 0, 0, ifaceExitCallback, 0},
  {0, 0, 0, 0, 0, 0, 0}
};

static const numFileMenuItems =
  sizeof(fileMenuItems)/sizeof(fileMenuItems[0]);

Widget ifaceCreatePulldownMenu(Widget parent, char *title,
                               char mnemonic, Boolean tearOff,
                               MenuItem *items);
 
void ifaceAddMwmCallback(Widget w, XtCallbackProc callback, void *context);

void ifaceStartBCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceStopBCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceHideBCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceShowBCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceInfoBCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceSelCallback(Widget w, XtPointer cld, XtPointer cad);
void ifaceInfoDoneCallback(Widget w, XtPointer cld, XtPointer cad);





Widget toplevel,MainForm,MenuBar,FilePullDown,list_w;
Widget pluginLabel,startButton,stopButton,hideButton,showButton,infoButton;
Widget infoPopup;
XtAppContext app;
Arg arg[10];
int n;
XmStringTable str_list;
extern int pluginCount;
int currentPluginChoice=-1;

void createInterface(int argc, char *argv[])
{
  int ci;

  XtSetLanguageProc(NULL,NULL,NULL);

  toplevel = XtVaAppInitialize(&app, "Plugin Manager Example",NULL,0,
			       &argc,argv,NULL,NULL);
  
  MainForm = XtVaCreateManagedWidget("main_w",
				     xmFormWidgetClass, toplevel,
				     XmNunitType, XmPIXELS,
				     XmNwidth, 400,
/*				     XmNheight, 400, */
				     XmNnoResize, True,
				     NULL);


  n=0;
  XtSetArg(arg[n],XmNrightAttachment, XmATTACH_FORM); n++;
  XtSetArg(arg[n],XmNleftAttachment, XmATTACH_FORM); n++;
  XtSetArg(arg[n],XmNtopAttachment, XmATTACH_FORM); n++;
/*
  XtSetArg(arg[n],XmNmenuAccelerator, "<KeyUp>F10"); n++;
*/
  MenuBar = XmCreateMenuBar(MainForm, "MenuBar",arg,n);
  
  FilePullDown = ifaceCreatePulldownMenu(MenuBar,"File",'F',False,
					 fileMenuItems);

  {
    XmString str=XmStringCreateLocalized("Plugin List");
    pluginLabel=XtVaCreateManagedWidget("plistlabel",
					xmLabelGadgetClass,
					MainForm,
					XmNlabelString,str,
					XmNleftAttachment,XmATTACH_FORM,
					XmNleftOffset,5,
					XmNtopAttachment,XmATTACH_WIDGET,
					XmNtopOffset,10,
					XmNtopWidget,MenuBar,
					NULL);
    XmStringFree(str);
  }

  str_list = (XmStringTable)XtMalloc(pluginCount * sizeof(XmString *));

  for(ci=0;ci<pluginCount;ci++)
    {
      str_list[ci]=XmStringCreateLocalized(dvePluginList[ci]->title);
    }

  n=0;
  XtSetArg(arg[n],XmNtopAttachment,XmATTACH_WIDGET);n++;
  XtSetArg(arg[n],XmNtopWidget,pluginLabel);n++;
  XtSetArg(arg[n],XmNtopOffset,15);n++;
  XtSetArg(arg[n],XmNleftAttachment,XmATTACH_FORM);n++;
  XtSetArg(arg[n],XmNrightAttachment,XmATTACH_FORM);n++;
  list_w=XmCreateScrolledList(MainForm,"Plugins",arg,n);
  XtVaSetValues(list_w,
		XmNitems, str_list,
		XmNitemCount, pluginCount,
		XmNvisibleItemCount, 10,
		XmNselectionPolicy,XmSINGLE_SELECT,
		NULL);
  XtManageChild(list_w);
  XtAddCallback(list_w,XmNsingleSelectionCallback,ifaceSelCallback,NULL);

  for(ci=0;ci<pluginCount;ci++)
    {
      XmStringFree(str_list[ci]);
    }
  XtFree(str_list);

  {
    XmString str=XmStringCreateLocalized("Start");
    startButton=XtVaCreateManagedWidget("startB",
					xmPushButtonWidgetClass,
					MainForm,
					XmNlabelString,str,
					XmNleftAttachment,XmATTACH_FORM,
					XmNleftOffset,30,
					XmNtopAttachment,XmATTACH_WIDGET,
					XmNtopWidget,list_w,
					XmNtopOffset,20,
					XmNbottomAttachment,XmATTACH_FORM,
					XmNbottomOffset,20,
					NULL);
    XmStringFree(str);
    XtAddCallback(startButton,XmNactivateCallback,ifaceStartBCallback,
		  (XtPointer)startButton);
    XtSetSensitive(startButton,False);
  }
  {
    XmString str=XmStringCreateLocalized("Stop");
    stopButton=XtVaCreateManagedWidget("stopB",
				       xmPushButtonWidgetClass,
				       MainForm,
				       XmNlabelString,str,
				       XmNleftAttachment,XmATTACH_WIDGET,
				       XmNleftWidget,startButton,
				       XmNleftOffset,30,
				       XmNtopAttachment,XmATTACH_WIDGET,
				       XmNtopWidget,list_w,
				       XmNtopOffset,20,
				       XmNbottomAttachment,XmATTACH_FORM,
				       XmNbottomOffset,20,
				       NULL);
    XmStringFree(str);
    XtAddCallback(stopButton,XmNactivateCallback,ifaceStopBCallback,
		  (XtPointer)stopButton);
    XtSetSensitive(stopButton,False);
  }
  {
    XmString str=XmStringCreateLocalized("Hide");
    hideButton=XtVaCreateManagedWidget("hideB",
				       xmPushButtonWidgetClass,
				       MainForm,
				       XmNlabelString,str,
				       XmNleftAttachment,XmATTACH_WIDGET,
				       XmNleftWidget,stopButton,
				       XmNleftOffset,30,
				       XmNtopAttachment,XmATTACH_WIDGET,
				       XmNtopWidget,list_w,
				       XmNtopOffset,20,
				       XmNbottomAttachment,XmATTACH_FORM,
				       XmNbottomOffset,20,
				       NULL);
    XmStringFree(str);
    XtAddCallback(hideButton,XmNactivateCallback,ifaceHideBCallback,
		  (XtPointer)hideButton);
    XtSetSensitive(hideButton,False);
  }
  {
    XmString str=XmStringCreateLocalized("Show");
    showButton=XtVaCreateManagedWidget("showB",
				       xmPushButtonWidgetClass,
				       MainForm,
				       XmNlabelString,str,
				       XmNleftAttachment,XmATTACH_WIDGET,
				       XmNleftWidget,hideButton,
				       XmNleftOffset,30,
				       XmNtopAttachment,XmATTACH_WIDGET,
				       XmNtopWidget,list_w,
				       XmNtopOffset,20,
				       XmNbottomAttachment,XmATTACH_FORM,
				       XmNbottomOffset,20,
				       NULL);
    XmStringFree(str);
    XtAddCallback(showButton,XmNactivateCallback,ifaceShowBCallback,
		  (XtPointer)showButton);
    XtSetSensitive(showButton,False);
  }
  {
    XmString str=XmStringCreateLocalized("Info...");
    infoButton=XtVaCreateManagedWidget("infoB",
				       xmPushButtonWidgetClass,
				       MainForm,
				       XmNlabelString,str,
				       XmNleftAttachment,XmATTACH_WIDGET,
				       XmNleftWidget,showButton,
				       XmNleftOffset,30,
				       XmNtopAttachment,XmATTACH_WIDGET,
				       XmNtopWidget,list_w,
				       XmNtopOffset,20,
				       XmNbottomAttachment,XmATTACH_FORM,
				       XmNbottomOffset,20,
				       NULL);
    XmStringFree(str);
    XtAddCallback(infoButton,XmNactivateCallback,ifaceInfoBCallback,
		  (XtPointer)infoButton);
    XtSetSensitive(infoButton,False);
  }
  
  XtManageChild(MenuBar);
  ifaceAddMwmCallback(toplevel,ifaceExitCallback,NULL);
  createInfoPopup();
  XtRealizeWidget(toplevel);
}


int ifaceShow()
{
  XtPopup(toplevel, XtGrabNone);

  return(0);
}

Widget ifaceCreatePulldownMenu(Widget parent, char *title,
			       char mnemonic, Boolean tearOff,
			       MenuItem *items)
{
  Widget pullDown, cascade;
  int i;
  XmString str;
  
  pullDown = XmCreatePulldownMenu(parent, "Pulldown", 0, 0);
  
  if (tearOff)
    XtVaSetValues(pullDown, XmNtearOffModel, XmTEAR_OFF_ENABLED, 0);
  
  str = XmStringCreateLocalized(title);
  
  cascade = XtVaCreateManagedWidget(title,
				    xmCascadeButtonWidgetClass, parent,
				    XmNsubMenuId, pullDown,
				    XmNlabelString, str,
				    XmNmnemonic, mnemonic,
				    0);
  
  XmStringFree(str);
  
  
  for (i = 0; items[i].label; i++) {
    Widget w = XtVaCreateManagedWidget(items[i].label,
				       *items[i].class, pullDown,
				       0);
    
    if (items[i].mnemonic)
      XtVaSetValues(w, XmNmnemonic, items[i].mnemonic, 0);
    
    if (items[i].accelerator) {
      XmString str = XmStringCreateLocalized(items[i].accelText);
      
      XtVaSetValues(w, XmNaccelerator, items[i].accelerator,
		    XmNacceleratorText, str, 
		    0);
      
      XmStringFree(str);
    }
    
    if (items[i].callback)
      XtAddCallback(w, XmNactivateCallback, items[i].callback, 
		    items[i].callbackData);
  }
  
  return cascade;
}





void ifaceAddMwmCallback(Widget w, XtCallbackProc callback, void *context)
{
  Atom WM_DELETE_WINDOW;

  
  WM_DELETE_WINDOW = XmInternAtom(XtDisplay(w), "WM_DELETE_WINDOW", False);

  XmAddWMProtocolCallback(w, WM_DELETE_WINDOW,
			  callback,
			  (XtPointer) context);
}

int createInfoPopup()
{
  infoPopup=(Widget)XmCreateMessageDialog(toplevel,"info",NULL,0);
  XtAddCallback(infoPopup,XmNokCallback,ifaceInfoDoneCallback,NULL);
  XtUnmanageChild(XmMessageBoxGetChild(infoPopup,XmDIALOG_CANCEL_BUTTON));
  XtUnmanageChild(XmMessageBoxGetChild(infoPopup,XmDIALOG_HELP_BUTTON));
  XtVaSetValues(infoPopup,
		XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL,
		NULL);
/*
  XtManageChild(infoPopup);
*/
}




void ifaceRunAllCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceRunAllCallback\n");
*/
  pluginStartAll();
}

void ifaceStopAllCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceStopAllCallback\n");
*/
  pluginStopAll();
}

void ifaceShowAllCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceShowAllCallback\n");
*/
  pluginShowAll();
}

void ifaceHideAllCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceHideAllCallback\n");
*/
  pluginHideAll();
}


void ifaceExitCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceExitCallback\n");
*/
  CleanupAndExit();
}

void ifaceStartBCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceStartBCallback\n");
*/
  if(currentPluginChoice>=0)
    pluginStart(currentPluginChoice);
}

void ifaceStopBCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceStopBCallback\n");
*/
  if(currentPluginChoice>=0)
    pluginStop(currentPluginChoice);
}

void ifaceHideBCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceHideBCallback\n");
*/
  if(currentPluginChoice>=0)
    pluginHide(currentPluginChoice);
}

void ifaceShowBCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceShowBCallback\n");
*/
  if(currentPluginChoice>=0)
    pluginShow(currentPluginChoice);
}


void ifaceInfoBCallback(Widget w, XtPointer cld, XtPointer cad)
{
  XmString str;
  char infoStr[1024];
  char tmpStr[256];

/*
  printf("ifaceInfoBCallback\n");
*/
  if(currentPluginChoice<0)
    return;
  sprintf(infoStr,"\nPlugin Name      : %s\n\n",
	  dvePluginList[currentPluginChoice]->name);
  sprintf(tmpStr,"Plugin Title     : %s\n\n",
	 dvePluginList[currentPluginChoice]->title);
  strcat(infoStr,tmpStr);
  sprintf(tmpStr,"Plugin Port      : %d\n\n",
	  (int)(dvePluginList[currentPluginChoice]->port));
  strcat(infoStr,tmpStr);
  sprintf(tmpStr,"Plugin ProcessId : %d\n\n",
	  dvePluginList[currentPluginChoice]->processID);
  strcat(infoStr,tmpStr);
/*
  sprintf(tmpStr,"Plugin Ready?    : %s\n\n",
	  (dvePluginList[currentPluginChoice]->pluginReady)?"Yes":"No");
  strcat(infoStr,tmpStr);
*/
  sprintf(tmpStr,"Plugin Path      : %s\n\n",
	  dvePluginList[currentPluginChoice]->basePath);
  strcat(infoStr,tmpStr);



  str=XmStringCreateLtoR(infoStr,XmFONTLIST_DEFAULT_TAG);
  XtVaSetValues(infoPopup,
		XmNmessageString,str,
		NULL);
  XtVaSetValues(XtParent(infoPopup),
		XmNtitle,"Plugin Information",
		NULL);
  XmStringFree(str);
  XtManageChild(infoPopup);
  XtPopup(XtParent(infoPopup),XtGrabNone);
}

void ifaceInfoDoneCallback(Widget w, XtPointer cld, XtPointer cad)
{
/*
  printf("ifaceInfoDoneCallback\n");
*/
  XtPopdown(XtParent(infoPopup));
}



void ifaceSelCallback(Widget w, XtPointer cld, XtPointer cad)
{
  XmListCallbackStruct *cbs=(XmListCallbackStruct *)cad;

/*
  printf("ifaceSelCallback\n");
*/
  currentPluginChoice=cbs->item_position-1;  
  XtSetSensitive(startButton,True);
  XtSetSensitive(stopButton,True);
  XtSetSensitive(hideButton,True);
  XtSetSensitive(showButton,True);
  XtSetSensitive(infoButton,True);  
}

















