#ifndef _DVE_AV_BROADCAST_H_
#define _DVE_AV_BROADCAST_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
  dveAVH320BroadcastModeInvalid=0,
  dveAVH320BroadcastModeLocal,
  dveAVH320BroadcastModeRemote,
  dveAVH320BroadcastModeAll
  } DveAVH320BroadcastMode;

typedef struct {
  u_int32 channelId;
  char channelDesc[256];
} DveAVH320BroadcastInfo;

/*
 * dveAVBroadcastH320Call
 *   "Broadcast" audio and video received from a H.320 call over a multicast
 *   connection
 *
 * Input : mode : Broadcast local video only, or remote video, or both?
 *         start : Start/Stop broadcast?
 *         
 * Output :
 * Return :
 * Notes :
 */
DveAVError dveAVBroadcastH320Call(DveAVSession session,
				  DveAVDomain domain, 
				  int start, 
				  DveAVH320BroadcastMode mode);
/*
 * dveAVSetH320BroadcastInfo
 *    Set H.320 channel broadcast info
 * 
 * Input : 
 * Output :
 * Return :
 * Notes :
 */
DveAVError dveAVSetH320BroadcastInfo(DveAVSession session,
				     DveAVH320BroadcastInfo *info);

#ifdef __cplusplus
} 
#endif

#endif /* _DVE_AV_BROADCAST_H_ */

