/*
 * $RCSfile$
 * $Date$
 * $Revision$
 * $Locker$
 * 
 * Description:
 *  Declares the conference manager plugin protocol, the protocol for
 *   messages passed between the engine and the manager for things like
 *   accept/reject conference.
 *
 * Requires:
 *  <dve/low.h>
 *
 * Includes:
 *  <dve/rejectionReasons.h>
 *
 * Implemented by:
 *  comm_confd/pluginmgr.c
 *  confmgr/
 *  ol_confmgr/
 *
 * Types:
 *  DveConfMgrMsgTag
 *  DveConfMgrInvitedArg
 *  DveConfMgrArg
 *
 * Author:
 *  francis, ?? Feb 1994
 *
 * Change Log:
 *  $Log$
 */
#ifndef _DVE_CONF_MANAGER_H_
#define _DVE_CONF_MANAGER_H_

#define IS_IDENT_STRING "@(#) $Id$"
#include <ISident.h>

#include <dve/rejectionReasons.h>

#ifdef __cplusplus
extern "C" {
#endif

enum {dveConfMgrPort=1};

/* Tags for plugin messages */
typedef enum 
{
  dveConfMgrMsgTagInvalid=0,
  /* engine->plugin: you're invited */
  dveConfMgrMsgTagInvited,
  /* plugin->engine: I accept/reject */
  dveConfMgrMsgTagAccept,
  dveConfMgrMsgTagReject,
  /* engine->plugin: you're invited, but don't prompt; you're in a conf */
  dveConfMgrMsgTagBadInvited
  } DveConfMgrMsgTag;

/* Who's in the conference, who initiated? */
typedef struct {
  int numParts, initiatorIndex;
  DveConfParticipant parts[1];
} DveConfMgrInvitedArg,
  DveConfMgrBadInvitedArg;

typedef union {
  DveConfMgrInvitedArg invited;
  DveConfMgrBadInvitedArg badInvited;
} DveConfMgrArg;

#ifdef __cplusplus
}
#endif

#endif /*_DVE_CONF_MANAGER_H_*/
