#ifndef _DVE_BOUNCE_FUNCTIONS_H_
#define _DVE_BOUNCE_FUNCTIONS_H_

#ifdef __cplusplus
extern "C" {
#endif

/* This header should also get the regular bounce calls, next time I get
 *  a chance to touch <dve/dve.h>.
 */

/* Callback invoked when you get a protocol bounce message (in reply to a 
 *  plugin message with the dveRoutingFlagGiveBounce flag set): the
 *  plugin's there, but it doesn't speak the protocol you were sending it.
 */
typedef void (*DveProtocolBounceCallback)(DveSession dveSession,
					  DveUserHandle handle,
					  DvePort port,
					  u_int32 pluginProtocol);
void dveSetProtocolBounceCallback(DveSession dveSession,
				  DveProtocolBounceCallback callback);
DveProtocolBounceCallback dveGetProtocolBounceCallback(DveSession dveSession);

#ifdef __cplusplus
}
#endif

#endif /*_DVE_BOUNCE_FUNCTIONS_H_*/
