#ifndef _OPENDVE_DVEHELP_H_
#define _OPENDVE_DVEHELP_H_
#ifdef __cplusplus
extern "C" {
#endif

/*
 * $RCSfile$
 * $Date$
 * $Revision$
 * $Locker$
 * 
 * Description:
 *  Declares the OpenDVE Help API.
 *
 * Requires:
 *  None
 *
 * Includes:
 *
 * Implemented by:
 *  dveHelp.c
 *
 * Types:
 *
 * Functions:
 *
 * Variables:
 *
 * Macros:
 *
//Required
 * Author:
 *	rhp - (9/7/94)
 *
 * Designer:
 *
//Required, if applicable
 * Known Bugs:
 *
 * Notes:
 *
//Required
 * Change Log:
 *  $Log$
 */

/*
 * Syntax:
 *   u_int32
 *   IS_DisplayHelpTopic(DveSession dveSession, char *pluginName,
 *                                      u_int32 helpItemIndex)
 * Description:
 *   This routine will tell the InSoft Help Viewer Plugin to display the help
 *   associated with the plugin called "pluginName". This help will reside
 *   with the plugin in a help subdirectory.
 *
 * Return value:
 *      u_int32	= 0 successful
 *		!=0 Problem sending OpenDVE message
 *
 * Implemented By:
 *   help.c
 *
 * Author:
 *   Richard H. Pizzarro (1/19/94)
 *
 */
u_int32
IS_DisplayHelpTopic(DveSession dveSession, char *pluginName,
                                        u_int32 helpItemIndex);

/* Add a plugin search path (equivalent of COMM_HOME or INTV_HOME) */
int IS_AddHelpPath(DveSession dveSession, const char* path);

#ifdef __cplusplus
}
#endif
#endif /*_OPENDVE_DVEHELP_H_*/
