/*
 * $RCSfile$
 * $Date$
 * $Revision$
 * $Locker$
 * 
 * Description:
 *  Declares rejection reasons.
 *
 * Requires:
 *
 * Includes:
 *
 * Implemented by:
 *  engine, confmgrs
 *
 * Author:
 *  francis, 10 Apr. 1995 (split off from <dve/low.h>).
 *
 * Known Bugs:
 *
 * Notes:
 *  This used to be in <dve/low.h>; when I had to add more reasons (the
 *   confdRejectionReasonRemoteCantConnect_* reasons) to support the case
 *   where not all invitees can talk to each other, I moved it out, since
 *   not all plugins need it, and I don't want to be touching <dve/low.h>
 *   again soon.  :-)
 *
 * Change Log:
 *  $Log$
 */
#ifndef _OPENDVE_CONFD_REJECTION_REASONS_H_
#define _OPENDVE_CONFD_REJECTION_REASONS_H_

#ifdef __cplusplus
extern "C" {
#endif

#define IS_IDENT_STRING "@(#) $Id$"
#include <ISident.h>

typedef enum {
  confdRejectionReasonInvalid=0,
  confdRejectionReasonNotPresent,
  confdRejectionReasonLineBusy,
  confdRejectionReasonRejected,
  confdRejectionReasonCantConnect_HostUnknown,
  confdRejectionReasonCantConnect_HostUnreachable,
  confdRejectionReasonCantConnect_NetworkUnreachable,
  confdRejectionReasonCantConnect_NoRegistrar,
  confdRejectionReasonCantConnect_NoEngine,
  confdRejectionReasonCantConnect_Local,
  confdRejectionReasonCantConnect_Unknown,

  /* New, added to support cleanly failing in a non-full-mesh case */
  confdRejectionReasonRemoteCantConnect_HostUnknown,
  confdRejectionReasonRemoteCantConnect_HostUnreachable,
  confdRejectionReasonRemoteCantConnect_NetworkUnreachable,
  confdRejectionReasonRemoteCantConnect_NoRegistrar,
  confdRejectionReasonRemoteCantConnect_NoEngine,
  confdRejectionReasonRemoteCantConnect_Local,
  confdRejectionReasonRemoteCantConnect_Unknown
  } ConfdRejectionReason;

#ifdef __cplusplus
}
#endif

#endif /*_OPENDVE_CONFD_REJECTION_REASONS_H_*/
