/*
 ********************************************************************
 *                InSoft Plugin Protocol Specification              *
 *                                                                  *
 *                       (c) 1995 InSoft, Inc.                      *
 ********************************************************************
 *
 * Name:        ISCameraToolPluginMotif
 *
 *
 * Description: 
 *
 * Author:      John D. Phillippy (3/7/95)
 *
 * Change Log:
 */

#ifndef CAMERA_PROTOCOL_VERSION
#define CAMERA_PROTOCOL_VERSION 4

#define REMOTE_CAMERA_PORT  10000

typedef enum {
  cameraTagInvalid = 0,     /* Never used */
  cameraTagLocal,           /* Is sent when local camera position is changed */
                            /* (by local or remote user) */
  cameraTagRemote,          /* Is sent when local user changes position */
                            /* of the remote camera */
  cameraTagPositionRequest, /* Retrieve position of the remote camera */
  cameraTagPositionReport                                   
} CameraTag;

typedef struct dveCameraArg {
  u_int32 dwPosition;
} DveCameraArg;

void htonDveCameraArg(DveCameraArg *pArg) {
  pArg->dwPosition = htonl(pArg->dwPosition);
}

void ntohDveCameraArg(DveCameraArg *pArg) {
  pArg->dwPosition = ntohl(pArg->dwPosition);
}

#endif        /* CAMERA_PROTOCOL_VERSION */
