
/*******************************************************************************
	topLevelShell1.c

       Associated Header file: topLevelShell1.h
*******************************************************************************/

#include <stdio.h>

#ifdef MOTIF
#include <Xm/Xm.h>
#include <Xm/MwmUtil.h>
#include <Xm/MenuShell.h>
#endif /* MOTIF */

#include "UxXt.h"

#include <Xm/Frame.h>
#include <Xm/List.h>
#include <Xm/ScrolledW.h>
#include <Xm/Separator.h>
#include <Xm/Label.h>
#include <Xm/Scale.h>
#include <Xm/TextF.h>
#include <Xm/CascadeB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <X11/Shell.h>

/*******************************************************************************
       Includes, Defines, and Global variables from the Declarations Editor:
*******************************************************************************/

#include <Xm/MenuShell.h>

#include "Plugin_procs.h"


static	int _UxIfClassId;
/*******************************************************************************
       The following header file defines the context structure.
*******************************************************************************/

#ifndef XKLOADDS
#define XKLOADDS
#endif /* XKLOADDS */

#define CONTEXT_MACRO_ACCESS 1
#include "topLevelShell1.h"
#undef CONTEXT_MACRO_ACCESS

Widget	topLevelShell1;
Widget	textField1;
Widget	localscale;
Widget	scrolledList1;
Widget	textField2;
Widget	remotescale;
Widget	footerlabel;

/*******************************************************************************
       The following are callback functions.
*******************************************************************************/

/*******************************************************************************
       The 'build_' function creates all the widgets
       using the resource values specified in the Property Editor.
*******************************************************************************/

static Widget	_Uxbuild_topLevelShell1()
{
	Widget		_UxParent;
	Widget		menu1_p1_shell;


	/* Creation of topLevelShell1 */
	_UxParent = UxParent;
	if ( _UxParent == NULL )
	{
		_UxParent = UxTopLevel;
	}

	topLevelShell1 = XtVaCreatePopupShell( "topLevelShell1",
			topLevelShellWidgetClass,
			_UxParent,
			XmNiconName, "Remote Camera Tool Example",
			XmNtitle, "Remote Camera Tool Example",
			XmNheight, 435,
			XmNwidth, 375,
			XmNinput, TRUE,
			XmNmwmDecorations, 2|16|32,
			XmNmwmFunctions, 4|8|32,
			NULL );
	XtAddCallback( topLevelShell1, XmNpopupCallback,
		(XtCallbackProc) topLevelShell1Init,
		(XtPointer) UxTopLevelShell1Context );

	UxPutContext( topLevelShell1, (char *) UxTopLevelShell1Context );


	/* Creation of form1 */
	form1 = XtVaCreateManagedWidget( "form1",
			xmFormWidgetClass,
			topLevelShell1,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNunitType, XmPIXELS,
			XmNwidth, 375,
			NULL );
	UxPutContext( form1, (char *) UxTopLevelShell1Context );


	/* Creation of menu1 */
	menu1 = XtVaCreateManagedWidget( "menu1",
			xmRowColumnWidgetClass,
			form1,
			XmNrowColumnType, XmMENU_BAR,
			XmNmenuAccelerator, "<KeyUp>F10",
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			NULL );
	UxPutContext( menu1, (char *) UxTopLevelShell1Context );


	/* Creation of menu1_p1 */
	menu1_p1_shell = XtVaCreatePopupShell ("menu1_p1_shell",
			xmMenuShellWidgetClass, menu1,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	menu1_p1 = XtVaCreateWidget( "menu1_p1",
			xmRowColumnWidgetClass,
			menu1_p1_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( menu1_p1, (char *) UxTopLevelShell1Context );


	/* Creation of menu1_p1_b1 */
	menu1_p1_b1 = XtVaCreateManagedWidget( "menu1_p1_b1",
			xmPushButtonGadgetClass,
			menu1_p1,
			RES_CONVERT( XmNlabelString, "Exit" ),
			RES_CONVERT( XmNmnemonic, "x" ),
			NULL );
	XtAddCallback( menu1_p1_b1, XmNactivateCallback,
		(XtCallbackProc) Exit_b_Callback,
		(XtPointer) UxTopLevelShell1Context );

	UxPutContext( menu1_p1_b1, (char *) UxTopLevelShell1Context );


	/* Creation of menu1_top_b1 */
	menu1_top_b1 = XtVaCreateManagedWidget( "menu1_top_b1",
			xmCascadeButtonWidgetClass,
			menu1,
			RES_CONVERT( XmNlabelString, "File" ),
			RES_CONVERT( XmNmnemonic, "F" ),
			XmNsubMenuId, menu1_p1,
			NULL );
	UxPutContext( menu1_top_b1, (char *) UxTopLevelShell1Context );


	/* Creation of localform */
	localform = XtVaCreateManagedWidget( "localform",
			xmFormWidgetClass,
			form1,
			XmNwidth, 85,
			XmNheight, 85,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNx, 100,
			XmNy, 60,
			XmNbottomAttachment, XmATTACH_NONE,
			XmNbottomWidget, NULL,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, menu1,
			NULL );
	UxPutContext( localform, (char *) UxTopLevelShell1Context );


	/* Creation of textField1 */
	textField1 = XtVaCreateManagedWidget( "textField1",
			xmTextFieldWidgetClass,
			localform,
			XmNwidth, 55,
			XmNx, 10,
			XmNy, 40,
			XmNheight, 35,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset, 10,
			XmNleftAttachment, XmATTACH_FORM,
			XmNleftOffset, 5,
			XmNeditable, TRUE,
			XmNcolumns, 4,
			XmNmaxLength, 4,
			XmNtopAttachment, XmATTACH_NONE,
			XmNtopOffset, 0,
			XmNvalue, "",
			XmNresizable, FALSE,
			NULL );
	XtAddCallback( textField1, XmNactivateCallback,
		(XtCallbackProc) textField1_Callback,
		(XtPointer) UxTopLevelShell1Context );

	UxPutContext( textField1, (char *) UxTopLevelShell1Context );


	/* Creation of localscale */
	localscale = XtVaCreateManagedWidget( "localscale",
			xmScaleWidgetClass,
			localform,
			XmNheight, 35,
			XmNorientation, XmHORIZONTAL,
			XmNx, 75,
			XmNy, 37,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset, 10,
			XmNleftAttachment, XmATTACH_WIDGET,
			XmNleftOffset, 10,
			XmNleftWidget, textField1,
			XmNrightAttachment, XmATTACH_FORM,
			XmNrightOffset, 5,
			XmNminimum, -100,
			XmNshowValue, TRUE,
			XmNtopAttachment, XmATTACH_NONE,
			XmNtopWidget, NULL,
			NULL );
	XtAddCallback( localscale, XmNvalueChangedCallback,
		(XtCallbackProc) reportLocal,
		(XtPointer) UxTopLevelShell1Context );

	UxPutContext( localscale, (char *) UxTopLevelShell1Context );


	/* Creation of label1 */
	label1 = XtVaCreateManagedWidget( "label1",
			xmLabelWidgetClass,
			localform,
			XmNx, 80,
			XmNy, 10,
			XmNwidth, 275,
			XmNheight, 25,
			RES_CONVERT( XmNlabelString, "Local Camera" ),
			XmNbottomAttachment, XmATTACH_WIDGET,
			XmNbottomWidget, localscale,
			XmNalignment, XmALIGNMENT_CENTER,
			XmNbottomOffset, 0,
			XmNleftOffset, 10,
			XmNleftAttachment, XmATTACH_WIDGET,
			XmNrightAttachment, XmATTACH_FORM,
			XmNrightOffset, 5,
			XmNleftWidget, textField1,
			XmNtopAttachment, XmATTACH_NONE,
			NULL );
	UxPutContext( label1, (char *) UxTopLevelShell1Context );


	/* Creation of separator1 */
	separator1 = XtVaCreateManagedWidget( "separator1",
			xmSeparatorWidgetClass,
			form1,
			XmNwidth, 20,
			XmNheight, 5,
			XmNx, 90,
			XmNy, 170,
			XmNrightAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopPosition, 45,
			XmNtopWidget, localform,
			NULL );
	UxPutContext( separator1, (char *) UxTopLevelShell1Context );


	/* Creation of remoteform */
	remoteform = XtVaCreateManagedWidget( "remoteform",
			xmFormWidgetClass,
			form1,
			XmNwidth, 160,
			XmNheight, 280,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNx, 35,
			XmNy, 125,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, separator1,
			XmNbottomAttachment, XmATTACH_NONE,
			NULL );
	UxPutContext( remoteform, (char *) UxTopLevelShell1Context );


	/* Creation of scrolledWindowList1 */
	scrolledWindowList1 = XtVaCreateManagedWidget( "scrolledWindowList1",
			xmScrolledWindowWidgetClass,
			remoteform,
			XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			XmNvisualPolicy, XmVARIABLE,
			XmNscrollBarDisplayPolicy, XmSTATIC,
			XmNshadowThickness, 1,
			XmNx, 45,
			XmNy, 100,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset, 5,
			XmNleftOffset, 5,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNrightOffset, 5,
			XmNtopAttachment, XmATTACH_NONE,
			XmNtopWidget, NULL,
			XmNtopOffset, 5,
			XmNheight, 180,
			XmNresizable, FALSE,
			NULL );
	UxPutContext( scrolledWindowList1, (char *) UxTopLevelShell1Context );


	/* Creation of scrolledList1 */
	scrolledList1 = XtVaCreateManagedWidget( "scrolledList1",
			xmListWidgetClass,
			scrolledWindowList1,
			XmNwidth, 205,
			XmNheight, 85,
			NULL );
	UxPutContext( scrolledList1, (char *) UxTopLevelShell1Context );


	/* Creation of textField2 */
	textField2 = XtVaCreateManagedWidget( "textField2",
			xmTextFieldWidgetClass,
			remoteform,
			XmNwidth, 55,
			XmNx, 5,
			XmNy, 85,
			XmNheight, 35,
			XmNtopOffset, 15,
			XmNleftOffset, 5,
			XmNleftAttachment, XmATTACH_FORM,
			XmNmaxLength, 4,
			XmNtopAttachment, XmATTACH_NONE,
			XmNbottomAttachment, XmATTACH_WIDGET,
			XmNbottomOffset, 10,
			XmNbottomWidget, scrolledWindowList1,
			NULL );
	XtAddCallback( textField2, XmNactivateCallback,
		(XtCallbackProc) textField2_Callback,
		(XtPointer) UxTopLevelShell1Context );

	UxPutContext( textField2, (char *) UxTopLevelShell1Context );


	/* Creation of remotescale */
	remotescale = XtVaCreateManagedWidget( "remotescale",
			xmScaleWidgetClass,
			remoteform,
			XmNwidth, 175,
			XmNheight, 35,
			XmNorientation, XmHORIZONTAL,
			XmNx, 75,
			XmNy, 35,
			XmNminimum, -100,
			XmNshowValue, TRUE,
			XmNbottomAttachment, XmATTACH_WIDGET,
			XmNbottomOffset, 10,
			XmNbottomWidget, scrolledWindowList1,
			XmNleftOffset, 10,
			XmNleftAttachment, XmATTACH_WIDGET,
			XmNleftWidget, textField2,
			XmNrightAttachment, XmATTACH_FORM,
			XmNrightOffset, 5,
			NULL );
	XtAddCallback( remotescale, XmNvalueChangedCallback,
		(XtCallbackProc) reportRemote,
		(XtPointer) UxTopLevelShell1Context );

	UxPutContext( remotescale, (char *) UxTopLevelShell1Context );


	/* Creation of label2 */
	label2 = XtVaCreateManagedWidget( "label2",
			xmLabelWidgetClass,
			remoteform,
			XmNx, 85,
			XmNy, 15,
			XmNwidth, 275,
			XmNheight, 25,
			RES_CONVERT( XmNlabelString, "Remote Camera" ),
			XmNalignment, XmALIGNMENT_CENTER,
			XmNleftAttachment, XmATTACH_WIDGET,
			XmNleftOffset, 10,
			XmNtopOffset, 10,
			XmNtopAttachment, XmATTACH_NONE,
			XmNleftWidget, textField2,
			XmNrightAttachment, XmATTACH_FORM,
			XmNrightOffset, 5,
			XmNbottomAttachment, XmATTACH_WIDGET,
			XmNbottomWidget, remotescale,
			NULL );
	UxPutContext( label2, (char *) UxTopLevelShell1Context );


	/* Creation of footerframe */
	footerframe = XtVaCreateManagedWidget( "footerframe",
			xmFrameWidgetClass,
			form1,
			XmNwidth, 280,
			XmNheight, 17,
			XmNx, 5,
			XmNy, 410,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, remoteform,
			XmNshadowType, XmSHADOW_OUT,
			XmNshadowThickness, 0,
			NULL );
	UxPutContext( footerframe, (char *) UxTopLevelShell1Context );


	/* Creation of form2 */
	form2 = XtVaCreateManagedWidget( "form2",
			xmFormWidgetClass,
			footerframe,
			XmNwidth, 215,
			XmNheight, 20,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNx, 130,
			XmNy, 10,
			XmNnavigationType, XmNONE,
			NULL );
	UxPutContext( form2, (char *) UxTopLevelShell1Context );


	/* Creation of frame1 */
	frame1 = XtVaCreateManagedWidget( "frame1",
			xmFrameWidgetClass,
			form2,
			XmNwidth, 350,
			XmNheight, 20,
			XmNx, 10,
			XmNy, 10,
			XmNtopAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNleftOffset, 0,
			XmNtopOffset, 0,
			XmNrightOffset, 0,
			XmNbottomOffset, 0,
			NULL );
	UxPutContext( frame1, (char *) UxTopLevelShell1Context );


	/* Creation of form3 */
	form3 = XtVaCreateManagedWidget( "form3",
			xmFormWidgetClass,
			frame1,
			XmNwidth, 200,
			XmNheight, 15,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNx, 85,
			XmNy, 5,
			XmNshadowThickness, 3,
			XmNshadowType, XmSHADOW_IN,
			NULL );
	UxPutContext( form3, (char *) UxTopLevelShell1Context );


	/* Creation of footerlabel */
	footerlabel = XtVaCreateManagedWidget( "footerlabel",
			xmLabelWidgetClass,
			form3,
			XmNx, 80,
			XmNy, 15,
			XmNwidth, 75,
			XmNheight, 10,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_FORM,
			XmNbottomOffset, 3,
			XmNleftOffset, 3,
			XmNrightOffset, 3,
			XmNtopOffset, 3,
			XmNalignment, XmALIGNMENT_END,
			RES_CONVERT( XmNlabelString, "" ),
			NULL );
	UxPutContext( footerlabel, (char *) UxTopLevelShell1Context );


	XtAddCallback( topLevelShell1, XmNdestroyCallback,
		(XtCallbackProc) UxDestroyContextCB,
		(XtPointer) UxTopLevelShell1Context);


	return ( topLevelShell1 );
}

/*******************************************************************************
       The following is the 'Interface function' which is the
       external entry point for creating this interface.
       This function should be called from your application or from
       a callback function.
*******************************************************************************/

Widget	create_topLevelShell1( swidget _UxUxParent )
{
	Widget                  rtrn;
	_UxCtopLevelShell1      *UxContext;
	static int		_Uxinit = 0;

	UxTopLevelShell1Context = UxContext =
		(_UxCtopLevelShell1 *) UxNewContext( sizeof(_UxCtopLevelShell1), False );

	UxParent = _UxUxParent;

	if ( ! _Uxinit )
	{
		_UxIfClassId = UxNewInterfaceClassId();
		_Uxinit = 1;
	}

	rtrn = _Uxbuild_topLevelShell1();
	UxPutClassCode( topLevelShell1, _UxIfClassId );

	return(rtrn);
}

/*******************************************************************************
       END OF FILE
*******************************************************************************/

