
/*******************************************************************************
	mpApplicationShell.c

       Associated Header file: mpApplicationShell.h
*******************************************************************************/

#include <stdio.h>

#ifdef MOTIF
#include <Xm/Xm.h>
#include <Xm/MwmUtil.h>
#include <Xm/MenuShell.h>
#endif /* MOTIF */

#include "UxXt.h"

#include <Xm/DrawingA.h>
#include <Xm/Label.h>
#include <Xm/Frame.h>
#include <Xm/CascadeB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <X11/Shell.h>



static	int _UxIfClassId;
/*******************************************************************************
       The following header file defines the context structure.
*******************************************************************************/

#ifndef XKLOADDS
#define XKLOADDS
#endif /* XKLOADDS */

#define CONTEXT_MACRO_ACCESS 1
#include "mpApplicationShell.h"
#undef CONTEXT_MACRO_ACCESS

Widget	mpApplicationShell;
Widget	mpMainForm;
Widget	mpMainMenu;
Widget	mpMainMenu_File;
Widget	mpMainMenu_File_button;
Widget	mpFooterFrame;
Widget	form1;
Widget	frame1;
Widget	mpFooterLabel;
Widget	mpDrawingFrame;
Widget	mpDrawingForm;
Widget	frame2;
Widget	drawingArea1;

/*******************************************************************************
       The following are callback functions.
*******************************************************************************/

static void  popupCB_mpApplicationShell(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCmpApplicationShell  *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxMpApplicationShellContext;
	UxMpApplicationShellContext = UxContext =
			(_UxCmpApplicationShell *) UxGetContext( UxWidget );
	dveAppInit();
	UxMpApplicationShellContext = UxSaveCtx;
}

static void  activateCB_mpMainMenu_File_Copy(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCmpApplicationShell  *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxMpApplicationShellContext;
	UxMpApplicationShellContext = UxContext =
			(_UxCmpApplicationShell *) UxGetContext( UxWidget );
	Copy_b_Callback();
	UxMpApplicationShellContext = UxSaveCtx;
}

static void  activateCB_mpMainMenu_File_Exit(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCmpApplicationShell  *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxMpApplicationShellContext;
	UxMpApplicationShellContext = UxContext =
			(_UxCmpApplicationShell *) UxGetContext( UxWidget );
	Exit_b_Callback();
	UxMpApplicationShellContext = UxSaveCtx;
}

/*******************************************************************************
       The 'build_' function creates all the widgets
       using the resource values specified in the Property Editor.
*******************************************************************************/

static Widget	_Uxbuild_mpApplicationShell()
{
	Widget		mpMainMenu_File_shell;


	/* Creation of mpApplicationShell */
	mpApplicationShell = XtVaCreatePopupShell( "mpApplicationShell",
			applicationShellWidgetClass,
			UxTopLevel,
			XmNiconName, "Motif Logo Plugin Example",
			XmNtitle, "Motif Logo Plugin Example",
			XmNallowShellResize, FALSE,
			XmNmwmDecorations, -1,
			NULL );
	XtAddCallback( mpApplicationShell, XmNpopupCallback,
		(XtCallbackProc) popupCB_mpApplicationShell,
		(XtPointer) UxMpApplicationShellContext );

	UxPutContext( mpApplicationShell, (char *) UxMpApplicationShellContext );


	/* Creation of mpMainForm */
	mpMainForm = XtVaCreateManagedWidget( "mpMainForm",
			xmFormWidgetClass,
			mpApplicationShell,
			XmNresizePolicy, XmRESIZE_ANY,
			XmNunitType, XmPIXELS,
			NULL );
	UxPutContext( mpMainForm, (char *) UxMpApplicationShellContext );


	/* Creation of mpMainMenu */
	mpMainMenu = XtVaCreateManagedWidget( "mpMainMenu",
			xmRowColumnWidgetClass,
			mpMainForm,
			XmNrowColumnType, XmMENU_BAR,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNmenuAccelerator, "<KeyUp>F10",
			NULL );
	UxPutContext( mpMainMenu, (char *) UxMpApplicationShellContext );


	/* Creation of mpMainMenu_File */
	mpMainMenu_File_shell = XtVaCreatePopupShell ("mpMainMenu_File_shell",
			xmMenuShellWidgetClass, mpMainMenu,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	mpMainMenu_File = XtVaCreateWidget( "mpMainMenu_File",
			xmRowColumnWidgetClass,
			mpMainMenu_File_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( mpMainMenu_File, (char *) UxMpApplicationShellContext );


	/* Creation of mpMainMenu_File_Copy */
	mpMainMenu_File_Copy = XtVaCreateManagedWidget( "mpMainMenu_File_Copy",
			xmPushButtonGadgetClass,
			mpMainMenu_File,
			RES_CONVERT( XmNlabelString, "Copy" ),
			RES_CONVERT( XmNmnemonic, "c" ),
			NULL );
	XtAddCallback( mpMainMenu_File_Copy, XmNactivateCallback,
		(XtCallbackProc) activateCB_mpMainMenu_File_Copy,
		(XtPointer) UxMpApplicationShellContext );

	UxPutContext( mpMainMenu_File_Copy, (char *) UxMpApplicationShellContext );


	/* Creation of mpMainMenu_File_Exit */
	mpMainMenu_File_Exit = XtVaCreateManagedWidget( "mpMainMenu_File_Exit",
			xmPushButtonGadgetClass,
			mpMainMenu_File,
			RES_CONVERT( XmNlabelString, "Exit" ),
			RES_CONVERT( XmNmnemonic, "x" ),
			NULL );
	XtAddCallback( mpMainMenu_File_Exit, XmNactivateCallback,
		(XtCallbackProc) activateCB_mpMainMenu_File_Exit,
		(XtPointer) UxMpApplicationShellContext );

	UxPutContext( mpMainMenu_File_Exit, (char *) UxMpApplicationShellContext );


	/* Creation of mpMainMenu_File_button */
	mpMainMenu_File_button = XtVaCreateManagedWidget( "mpMainMenu_File_button",
			xmCascadeButtonWidgetClass,
			mpMainMenu,
			RES_CONVERT( XmNlabelString, "File" ),
			RES_CONVERT( XmNmnemonic, "F" ),
			XmNsubMenuId, mpMainMenu_File,
			NULL );
	UxPutContext( mpMainMenu_File_button, (char *) UxMpApplicationShellContext );


	/* Creation of mpFooterFrame */
	mpFooterFrame = XtVaCreateManagedWidget( "mpFooterFrame",
			xmFrameWidgetClass,
			mpMainForm,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNshadowType, XmSHADOW_IN,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNshadowThickness, 1,
			XmNtopAttachment, XmATTACH_NONE,
			XmNtopWidget, NULL,
			XmNtopPosition, 0,
			XmNtopOffset, 0,
			NULL );
	UxPutContext( mpFooterFrame, (char *) UxMpApplicationShellContext );


	/* Creation of form1 */
	form1 = XtVaCreateManagedWidget( "form1",
			xmFormWidgetClass,
			mpFooterFrame,
			XmNresizePolicy, XmRESIZE_ANY,
			XmNshadowThickness, 0,
			XmNshadowType, XmSHADOW_IN,
			XmNheight, 31,
			NULL );
	UxPutContext( form1, (char *) UxMpApplicationShellContext );


	/* Creation of frame1 */
	frame1 = XtVaCreateManagedWidget( "frame1",
			xmFrameWidgetClass,
			form1,
			XmNx, 0,
			XmNy, 0,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNleftOffset, 2,
			XmNbottomPosition, 2,
			XmNrightOffset, 2,
			XmNtopOffset, 2,
			XmNbottomOffset, 2,
			XmNshadowType, XmSHADOW_IN,
			XmNshadowThickness, 3,
			NULL );
	UxPutContext( frame1, (char *) UxMpApplicationShellContext );


	/* Creation of mpFooterLabel */
	mpFooterLabel = XtVaCreateManagedWidget( "mpFooterLabel",
			xmLabelWidgetClass,
			frame1,
			RES_CONVERT( XmNlabelString, "" ),
			NULL );
	UxPutContext( mpFooterLabel, (char *) UxMpApplicationShellContext );


	/* Creation of mpDrawingFrame */
	mpDrawingFrame = XtVaCreateManagedWidget( "mpDrawingFrame",
			xmFrameWidgetClass,
			mpMainForm,
			XmNx, 10,
			XmNy, 40,
			XmNbottomAttachment, XmATTACH_WIDGET,
			XmNbottomWidget, mpFooterFrame,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, mpMainMenu,
			XmNheight, 250,
			XmNwidth, 250,
			NULL );
	UxPutContext( mpDrawingFrame, (char *) UxMpApplicationShellContext );


	/* Creation of mpDrawingForm */
	mpDrawingForm = XtVaCreateManagedWidget( "mpDrawingForm",
			xmFormWidgetClass,
			mpDrawingFrame,
			XmNresizePolicy, XmRESIZE_ANY,
			XmNshadowThickness, 0,
			XmNshadowType, XmSHADOW_IN,
			NULL );
	UxPutContext( mpDrawingForm, (char *) UxMpApplicationShellContext );


	/* Creation of frame2 */
	frame2 = XtVaCreateManagedWidget( "frame2",
			xmFrameWidgetClass,
			mpDrawingForm,
			XmNx, 70,
			XmNy, 20,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset, 2,
			XmNleftOffset, 2,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNrightOffset, 2,
			XmNtopAttachment, XmATTACH_FORM,
			XmNtopOffset, 2,
			XmNshadowType, XmSHADOW_IN,
			XmNshadowThickness, 3,
			NULL );
	UxPutContext( frame2, (char *) UxMpApplicationShellContext );


	/* Creation of drawingArea1 */
	drawingArea1 = XtVaCreateManagedWidget( "drawingArea1",
			xmDrawingAreaWidgetClass,
			frame2,
			XmNresizePolicy, XmRESIZE_ANY,
			XmNx, 130,
			XmNy, 130,
			NULL );
	UxPutContext( drawingArea1, (char *) UxMpApplicationShellContext );


	XtAddCallback( mpApplicationShell, XmNdestroyCallback,
		(XtCallbackProc) UxDestroyContextCB,
		(XtPointer) UxMpApplicationShellContext);


	return ( mpApplicationShell );
}

/*******************************************************************************
       The following is the 'Interface function' which is the
       external entry point for creating this interface.
       This function should be called from your application or from
       a callback function.
*******************************************************************************/

Widget	create_mpApplicationShell()
{
	Widget                  rtrn;
	_UxCmpApplicationShell  *UxContext;
	static int		_Uxinit = 0;

	UxMpApplicationShellContext = UxContext =
		(_UxCmpApplicationShell *) UxNewContext( sizeof(_UxCmpApplicationShell), False );


	if ( ! _Uxinit )
	{
		_UxIfClassId = UxNewInterfaceClassId();
		_Uxinit = 1;
	}

	rtrn = _Uxbuild_mpApplicationShell();
	UxPutClassCode( mpApplicationShell, _UxIfClassId );

	return(rtrn);
}

/*******************************************************************************
       END OF FILE
*******************************************************************************/

