#########################################################################
# 
#    	MAKEFILE FOR STAND-ALONE APPLICATION [XT-CODE].
#
#       EXECUTABLE      is the name of the executable to be created 
#       MAIN            is the .c file containing your main() function
#       INTERFACES      is a list of the generated C code files 
#       APP_OBJS        is a (possibly empty) list of the object code
#                       files that form the non-interface portion of
#                       your application 
#
#       In the first several statements, the variables on the right 
#	of the equal sign will be replaced with their corresponding 
#       values when the makefile is automatically generated. 
#
#       This template is used for makefiles which do not reference
#       the Ux runtime library.
#
#  	$Date: 94/05/10 03:09:57 $ 		$Revision: 1.1 $
#########################################################################

OPENDVE_HOME	= /insoft/vault/production/communique

EXECUTABLE	= ISLogoPluginMotif
MAIN		= ISLogoPluginMotif.c
INTERFACES	= 	Plugin_procs.c OpenDVE_procs.c mpApplicationShell.c

LANGUAGE        = ANSI C
APPL_OBJS       = UxXt.o UxMethod.o

UIL_FILES       =
UILFILES        =
UIDFILES        =
UIL	        =
# UIL compiler, if needed, must be in PATH, or be an absolute pathname.

CODE_TYPE       = XT-CODE
UX_DIR	        = /usr/uimx2.6
UX_LIBPATH      =
UX_INCPATH      =
UX_LIB	        =
DXT	        = -DXT_CODE
DUIL	        =
MRMLIB	        =



# Changes below this line may be appropriate for other templates as well.

SHELL		= /bin/sh

X_LIBS	        = $(MRMLIB) -lXm -lXt -lX11

X_LIBPATH       = -L/usr/lib/X11R5
MOTIF_LIBPATH   = -L/usr/lib/Motif1.2
X_CFLAGS        = -I/usr/include/X11R5
MOTIF_CFLAGS    = -DMOTIF -I/usr/include/Motif1.2

ANSI_CC         = cc 
ANSI_CFLAGS	= -Aa

CFLAGS          = -Y -DSYSV -DXOPEN_CATALOG \
		  $(UX_INCPATH) \
		  $(X_CFLAGS) $(MOTIF_CFLAGS) $(DXT) $(DUIL) \
		  +DA1.0 +DS1.1 \
		  -DXT \
		  -D_INCLUDE_HPUX_SOURCE \
		  -D_INCLUDE_XOPEN_SOURCE \
		  -D_INCLUDE_POSIX_SOURCE \
		  -I$(OPENDVE_HOME)/package/hpux/include \
		  -I$(OPENDVE_HOME)/package/common/include \
		  /usr/openwin/include 
LIBPATH	        = $(UX_LIBPATH) $(MOTIF_LIBPATH) $(X_LIBPATH) \
		  -L$(OPENDVE_HOME)/package/hpux/lib
LIBS            = $(UX_LIB) -ldveXt -ldveClip -ldveImaging $(X_LIBS) -lPW -lm 


OBJS = $(MAIN:.c=.o) $(INTERFACES:.c=.o) \
       $(APPL_OBJS) $(EXTRA_OBJS)

$(EXECUTABLE): $(OBJS) $(UIDFILES)
	@echo Linking    $(EXECUTABLE)
	@$(CC) $(OBJS) $(LIBPATH) $(LIBS) -o $(EXECUTABLE)
	@echo "Done"



.SUFFIXES: 
.SUFFIXES: .o .uil .uid .c .c

.c.o:
	@echo Compiling $< [$(LANGUAGE)] [$(CODE_TYPE)]
	$(CC) -c $(CFLAGS) $< -o $@
.c.o:
	@echo Compiling $< [$(LANGUAGE)] [$(CODE_TYPE)]
	$(CC) -c $(CFLAGS) $< -o $@

.uil.uid:
	@echo Compiling  $< [UIL]
	@$(UIL) -s $< -o $@
# Remove -s option from previous line for UIL compiles without locale flag set


UxMethod.o: UxMethod.c
	@echo Compiling $< [ANSI-C] [$(CODE_TYPE)]
	@$(ANSI_CC) $(ANSI_CFLAGS) $(CFLAGS) -c $< -o $@

CC = $(ANSI_CC) $(ANSI_CFLAGS)
LD = $(ANSI_CC)
LD_FLAGS = $(ANSI_LDFLAGS)

clean:
	rm -f core *.o $(PROGRAM)
