
/*******************************************************************************
	rpApplicationShell.c

       Associated Header file: rpApplicationShell.h
*******************************************************************************/

#include <stdio.h>

#ifdef MOTIF
#include <Xm/Xm.h>
#include <Xm/MwmUtil.h>
#include <Xm/MenuShell.h>
#endif /* MOTIF */

#include "UxXt.h"

#include <Xm/List.h>
#include <Xm/ScrolledW.h>
#include <Xm/Label.h>
#include <Xm/Frame.h>
#include <Xm/LabelG.h>
#include <Xm/CascadeB.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Form.h>
#include <X11/Shell.h>

/*******************************************************************************
       Includes, Defines, and Global variables from the Declarations Editor:
*******************************************************************************/

#include "ISRecipientPluginMotif.h"


static	int _UxIfClassId;
/*******************************************************************************
       The following header file defines the context structure.
*******************************************************************************/

#ifndef XKLOADDS
#define XKLOADDS
#endif /* XKLOADDS */

#define CONTEXT_MACRO_ACCESS 1
#include "rpApplicationShell.h"
#undef CONTEXT_MACRO_ACCESS

Widget	recipTestAppShell;
Widget	label1;
Widget	recipTestSingleList;
Widget	recipTestList;

/*******************************************************************************
       The following are callback functions.
*******************************************************************************/

static void  activateCB_recipTestMainMenu_File_Exit(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCrecipTestAppShell   *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxRecipTestAppShellContext;
	UxRecipTestAppShellContext = UxContext =
			(_UxCrecipTestAppShell *) UxGetContext( UxWidget );
	recipTestQuit();
	UxRecipTestAppShellContext = UxSaveCtx;
}

static void  activateCB_recipTestMainMenu_Members_List(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCrecipTestAppShell   *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxRecipTestAppShellContext;
	UxRecipTestAppShellContext = UxContext =
			(_UxCrecipTestAppShell *) UxGetContext( UxWidget );
	recipTestListMembers();
	UxRecipTestAppShellContext = UxSaveCtx;
}

static void  activateCB_recipTestMainMenu_Members_SelectAll(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCrecipTestAppShell   *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxRecipTestAppShellContext;
	UxRecipTestAppShellContext = UxContext =
			(_UxCrecipTestAppShell *) UxGetContext( UxWidget );
	{recipTestSelectAll();}
	UxRecipTestAppShellContext = UxSaveCtx;
}

static void  activateCB_recipTestMainMenu_Members_DeselectAll(
			Widget wgt, 
			XtPointer cd, 
			XtPointer cb)
{
	_UxCrecipTestAppShell   *UxSaveCtx, *UxContext;
	Widget                  UxWidget = wgt;
	XtPointer               UxClientData = cd;
	XtPointer               UxCallbackArg = cb;

	UxSaveCtx = UxRecipTestAppShellContext;
	UxRecipTestAppShellContext = UxContext =
			(_UxCrecipTestAppShell *) UxGetContext( UxWidget );
	{recipTestDeselectAll();}
	UxRecipTestAppShellContext = UxSaveCtx;
}

/*******************************************************************************
       The 'build_' function creates all the widgets
       using the resource values specified in the Property Editor.
*******************************************************************************/

static Widget	_Uxbuild_recipTestAppShell()
{
	Widget		_UxParent;
	Widget		recipTestMainMenu_File_shell;
	Widget		recipTestMainMenu_Members_shell;


	/* Creation of recipTestAppShell */
	_UxParent = UxParent;
	if ( _UxParent == NULL )
	{
		_UxParent = UxTopLevel;
	}

	recipTestAppShell = XtVaCreatePopupShell( "recipTestAppShell",
			applicationShellWidgetClass,
			_UxParent,
			XmNx, 370,
			XmNy, 300,
			XmNtitle, "Recipient List Plugin Example",
			XmNiconName, "Recipient List Plugin Example",
			NULL );
	UxPutContext( recipTestAppShell, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainForm */
	recipTestMainForm = XtVaCreateManagedWidget( "recipTestMainForm",
			xmFormWidgetClass,
			recipTestAppShell,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNunitType, XmPIXELS,
			XmNheight, 300,
			XmNwidth, 325,
			NULL );
	UxPutContext( recipTestMainForm, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainMenu */
	recipTestMainMenu = XtVaCreateManagedWidget( "recipTestMainMenu",
			xmRowColumnWidgetClass,
			recipTestMainForm,
			XmNrowColumnType, XmMENU_BAR,
			XmNmenuAccelerator, "<KeyUp>F10",
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			NULL );
	UxPutContext( recipTestMainMenu, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainMenu_File */
	recipTestMainMenu_File_shell = XtVaCreatePopupShell ("recipTestMainMenu_File_shell",
			xmMenuShellWidgetClass, recipTestMainMenu,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	recipTestMainMenu_File = XtVaCreateWidget( "recipTestMainMenu_File",
			xmRowColumnWidgetClass,
			recipTestMainMenu_File_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( recipTestMainMenu_File, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainMenu_File_Exit */
	recipTestMainMenu_File_Exit = XtVaCreateManagedWidget( "recipTestMainMenu_File_Exit",
			xmPushButtonWidgetClass,
			recipTestMainMenu_File,
			RES_CONVERT( XmNlabelString, "Exit" ),
			RES_CONVERT( XmNmnemonic, "x" ),
			NULL );
	XtAddCallback( recipTestMainMenu_File_Exit, XmNactivateCallback,
		(XtCallbackProc) activateCB_recipTestMainMenu_File_Exit,
		(XtPointer) UxRecipTestAppShellContext );

	UxPutContext( recipTestMainMenu_File_Exit, (char *) UxRecipTestAppShellContext );


	/* Creation of menuBar_top_File */
	menuBar_top_File = XtVaCreateManagedWidget( "menuBar_top_File",
			xmCascadeButtonWidgetClass,
			recipTestMainMenu,
			RES_CONVERT( XmNlabelString, "File" ),
			XmNsubMenuId, recipTestMainMenu_File,
			RES_CONVERT( XmNmnemonic, "F" ),
			NULL );
	UxPutContext( menuBar_top_File, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainMenu_Members */
	recipTestMainMenu_Members_shell = XtVaCreatePopupShell ("recipTestMainMenu_Members_shell",
			xmMenuShellWidgetClass, recipTestMainMenu,
			XmNwidth, 1,
			XmNheight, 1,
			XmNallowShellResize, TRUE,
			XmNoverrideRedirect, TRUE,
			NULL );

	recipTestMainMenu_Members = XtVaCreateWidget( "recipTestMainMenu_Members",
			xmRowColumnWidgetClass,
			recipTestMainMenu_Members_shell,
			XmNrowColumnType, XmMENU_PULLDOWN,
			NULL );
	UxPutContext( recipTestMainMenu_Members, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainMenu_Members_List */
	recipTestMainMenu_Members_List = XtVaCreateManagedWidget( "recipTestMainMenu_Members_List",
			xmPushButtonGadgetClass,
			recipTestMainMenu_Members,
			RES_CONVERT( XmNlabelString, "List" ),
			RES_CONVERT( XmNmnemonic, "L" ),
			NULL );
	XtAddCallback( recipTestMainMenu_Members_List, XmNactivateCallback,
		(XtCallbackProc) activateCB_recipTestMainMenu_Members_List,
		(XtPointer) UxRecipTestAppShellContext );

	UxPutContext( recipTestMainMenu_Members_List, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainMenu_Members_SelectAll */
	recipTestMainMenu_Members_SelectAll = XtVaCreateManagedWidget( "recipTestMainMenu_Members_SelectAll",
			xmPushButtonGadgetClass,
			recipTestMainMenu_Members,
			RES_CONVERT( XmNlabelString, "Select All" ),
			RES_CONVERT( XmNmnemonic, "A" ),
			NULL );
	XtAddCallback( recipTestMainMenu_Members_SelectAll, XmNactivateCallback,
		(XtCallbackProc) activateCB_recipTestMainMenu_Members_SelectAll,
		(XtPointer) UxRecipTestAppShellContext );

	UxPutContext( recipTestMainMenu_Members_SelectAll, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainMenu_Members_DeselectAll */
	recipTestMainMenu_Members_DeselectAll = XtVaCreateManagedWidget( "recipTestMainMenu_Members_DeselectAll",
			xmPushButtonGadgetClass,
			recipTestMainMenu_Members,
			RES_CONVERT( XmNlabelString, "Deselect All" ),
			RES_CONVERT( XmNmnemonic, "D" ),
			NULL );
	XtAddCallback( recipTestMainMenu_Members_DeselectAll, XmNactivateCallback,
		(XtCallbackProc) activateCB_recipTestMainMenu_Members_DeselectAll,
		(XtPointer) UxRecipTestAppShellContext );

	UxPutContext( recipTestMainMenu_Members_DeselectAll, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMainMenu_top_Members */
	recipTestMainMenu_top_Members = XtVaCreateManagedWidget( "recipTestMainMenu_top_Members",
			xmCascadeButtonWidgetClass,
			recipTestMainMenu,
			RES_CONVERT( XmNlabelString, "Members" ),
			RES_CONVERT( XmNmnemonic, "M" ),
			XmNsubMenuId, recipTestMainMenu_Members,
			NULL );
	UxPutContext( recipTestMainMenu_top_Members, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestMultiLabel */
	recipTestMultiLabel = XtVaCreateManagedWidget( "recipTestMultiLabel",
			xmLabelGadgetClass,
			recipTestMainForm,
			RES_CONVERT( XmNlabelString, "Multiple selection:" ),
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_POSITION,
			XmNrightPosition, 50,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, recipTestMainMenu,
			XmNmarginLeft, 10,
			XmNmarginRight, 10,
			NULL );
	UxPutContext( recipTestMultiLabel, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestSingleLabel */
	recipTestSingleLabel = XtVaCreateManagedWidget( "recipTestSingleLabel",
			xmLabelGadgetClass,
			recipTestMainForm,
			XmNleftAttachment, XmATTACH_POSITION,
			XmNleftPosition, 50,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, recipTestMainMenu,
			RES_CONVERT( XmNlabelString, "Browse selection:" ),
			XmNmarginLeft, 10,
			XmNmarginRight, 10,
			NULL );
	UxPutContext( recipTestSingleLabel, (char *) UxRecipTestAppShellContext );


	/* Creation of frame1 */
	frame1 = XtVaCreateManagedWidget( "frame1",
			xmFrameWidgetClass,
			recipTestMainForm,
			XmNwidth, 170,
			XmNheight, 35,
			XmNx, 130,
			XmNy, 270,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNleftAttachment, XmATTACH_FORM,
			XmNleftOffset, 0,
			XmNresizable, FALSE,
			XmNrightAttachment, XmATTACH_FORM,
			NULL );
	UxPutContext( frame1, (char *) UxRecipTestAppShellContext );


	/* Creation of form1 */
	form1 = XtVaCreateManagedWidget( "form1",
			xmFormWidgetClass,
			frame1,
			XmNwidth, 170,
			XmNheight, 20,
			XmNresizePolicy, XmRESIZE_NONE,
			XmNx, 80,
			XmNy, 10,
			XmNshadowThickness, 3,
			XmNshadowType, XmSHADOW_IN,
			NULL );
	UxPutContext( form1, (char *) UxRecipTestAppShellContext );


	/* Creation of label1 */
	label1 = XtVaCreateManagedWidget( "label1",
			xmLabelWidgetClass,
			form1,
			XmNx, 70,
			XmNy, 10,
			XmNwidth, 60,
			XmNheight, 20,
			XmNbottomAttachment, XmATTACH_FORM,
			XmNbottomOffset, 5,
			XmNleftOffset, 5,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_FORM,
			XmNtopOffset, 5,
			XmNrightOffset, 5,
			XmNalignment, XmALIGNMENT_BEGINNING,
			RES_CONVERT( XmNlabelString, "" ),
			NULL );
	UxPutContext( label1, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestSingleListScrolledWindow */
	recipTestSingleListScrolledWindow = XtVaCreateManagedWidget( "recipTestSingleListScrolledWindow",
			xmScrolledWindowWidgetClass,
			recipTestMainForm,
			XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			XmNvisualPolicy, XmVARIABLE,
			XmNscrollBarDisplayPolicy, XmSTATIC,
			XmNshadowThickness, 0,
			XmNleftAttachment, XmATTACH_POSITION,
			XmNleftPosition, 50,
			XmNrightAttachment, XmATTACH_FORM,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, recipTestSingleLabel,
			XmNrightOffset, 4,
			XmNleftOffset, 2,
			XmNbottomAttachment, XmATTACH_WIDGET,
			XmNbottomOffset, 4,
			XmNbottomWidget, frame1,
			NULL );
	UxPutContext( recipTestSingleListScrolledWindow, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestSingleList */
	recipTestSingleList = XtVaCreateManagedWidget( "recipTestSingleList",
			xmListWidgetClass,
			recipTestSingleListScrolledWindow,
			NULL );
	UxPutContext( recipTestSingleList, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestListScrolledWindow */
	recipTestListScrolledWindow = XtVaCreateManagedWidget( "recipTestListScrolledWindow",
			xmScrolledWindowWidgetClass,
			recipTestMainForm,
			XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			XmNvisualPolicy, XmVARIABLE,
			XmNscrollBarDisplayPolicy, XmSTATIC,
			XmNshadowThickness, 0,
			XmNx, 190,
			XmNy, 80,
			XmNleftAttachment, XmATTACH_FORM,
			XmNrightAttachment, XmATTACH_POSITION,
			XmNtopAttachment, XmATTACH_WIDGET,
			XmNtopWidget, recipTestMultiLabel,
			XmNrightPosition, 50,
			XmNleftOffset, 4,
			XmNrightOffset, 2,
			XmNbottomAttachment, XmATTACH_WIDGET,
			XmNbottomOffset, 4,
			XmNbottomWidget, frame1,
			NULL );
	UxPutContext( recipTestListScrolledWindow, (char *) UxRecipTestAppShellContext );


	/* Creation of recipTestList */
	recipTestList = XtVaCreateManagedWidget( "recipTestList",
			xmListWidgetClass,
			recipTestListScrolledWindow,
			XmNselectionPolicy, XmMULTIPLE_SELECT,
			NULL );
	UxPutContext( recipTestList, (char *) UxRecipTestAppShellContext );


	XtAddCallback( recipTestAppShell, XmNdestroyCallback,
		(XtCallbackProc) UxDestroyContextCB,
		(XtPointer) UxRecipTestAppShellContext);


	return ( recipTestAppShell );
}

/*******************************************************************************
       The following is the 'Interface function' which is the
       external entry point for creating this interface.
       This function should be called from your application or from
       a callback function.
*******************************************************************************/

Widget	create_recipTestAppShell( swidget _UxUxParent )
{
	Widget                  rtrn;
	_UxCrecipTestAppShell   *UxContext;
	static int		_Uxinit = 0;

	UxRecipTestAppShellContext = UxContext =
		(_UxCrecipTestAppShell *) UxNewContext( sizeof(_UxCrecipTestAppShell), False );

	UxParent = _UxUxParent;

	if ( ! _Uxinit )
	{
		_UxIfClassId = UxNewInterfaceClassId();
		_Uxinit = 1;
	}

	rtrn = _Uxbuild_recipTestAppShell();
	UxPutClassCode( recipTestAppShell, _UxIfClassId );

	return(rtrn);
}

/*******************************************************************************
       END OF FILE
*******************************************************************************/

