/*
 * $RCSfile$
 * $Date$
 * $Revision$
 * $Locker$
 * 
 * Description:
 *  Provides the declaration of malloc() and free(), which aren't always
 *   in <stdlib.h> as they should be; also gives typedefs for the pointer
 *   type malloc() returns and free() accepts and for the arithmetic type
 *   malloc() accepts for size.
 *
 * Includes:
 *  Most systems: <stdlib.h>
 *  SunOS: <malloc.h>
 *
 * Implemented by:
 *  libc
 *
 * Types:
 *  IS_mallocReturnType
 *  IS_mallocSizeType
 *
 * Functions:
 *  malloc()
 *  free()
 *
 * Author:
 *  francis, ?? Mar 1994
 *
 * Change Log:
 *  $Log$
 */
#ifndef _INSOFT_SYS_MALLOC_H_
#define _INSOFT_SYS_MALLOC_H_

#ifdef __cplusplus
extern "C" {
#endif

#define IS_IDENT_STRING "@(#) $Id$"
#include <ISident.h>

#ifdef IS_PLATFORM_SUNOS

#include <malloc.h>
/* Return type from malloc() */
typedef char IS_mallocReturnType;
/* Argument type for malloc() */
typedef unsigned IS_mallocSizeType;

#else

#include <stdlib.h>
/* Return type from malloc() */
typedef void IS_mallocReturnType;
/* Argument type for malloc() */
typedef size_t IS_mallocSizeType;

#endif /*IS_PLATFORM_SUNOS*/

#ifdef __cplusplus
}
#endif

#endif /*_INSOFT_SYS_MALLOC_H_*/
